package google.visualization;

import jsinterop.annotations.JsConstructor;
import jsinterop.annotations.JsOverlay;
import jsinterop.annotations.JsPackage;
import jsinterop.annotations.JsProperty;
import jsinterop.annotations.JsType;

/**
 * Class generated by scraping: https://developers.google.com/chart/interactive/docs/gallery/[doc]
 * using
 *
 * @author <a href="mailto:Roland.Schweitzer@gmail.com">Roland Schweitzer</a>
 */
@JsType(isNative = true, namespace = JsPackage.GLOBAL, name = "Object")
public class PieChartOptions {

    @JsConstructor
    public PieChartOptions() {

    }


    @JsProperty
    Object[] slices;
    @JsProperty
    Object backgroundColor;
    @JsProperty
    Object pieSliceTextStyle;
    @JsProperty
    Object legend;
    @JsProperty
    String pieSliceBorderColor;
    @JsProperty
    Object tooltip;
    @JsProperty
    Boolean is3D;
    @JsProperty
    String title;
    @JsProperty
    String[] colors;
    @JsProperty
    Object titleTextStyle;
    @JsProperty
    String pieSliceText;
    @JsProperty
    Boolean reverseCategories;
    @JsProperty
    String fontName;
    @JsProperty
    Number pieStartAngle;
    @JsProperty
    Number sliceVisibilityThreshold;
    @JsProperty
    Boolean forceIFrame;
    @JsProperty
    Number pieHole;
    @JsProperty
    String pieResidueSliceColor;
    @JsProperty
    Boolean enableInteractivity;
    @JsProperty
    Number width;
    @JsProperty
    Number fontSize;
    @JsProperty
    Object chartArea;
    @JsProperty
    Number height;
    @JsProperty
    String pieResidueSliceLabel;

    @JsOverlay
    public final Object[] getSlices() {
        return this.slices;
    }

    @JsOverlay
    public final void setSlices(Object[] slices) {
        this.slices = slices;
    }

    @JsOverlay
    public final Object getBackgroundColor() {
        return this.backgroundColor;
    }

    @JsOverlay
    public final void setBackgroundColor(Object backgroundColor) {
        this.backgroundColor = backgroundColor;
    }

    @JsOverlay
    public final Object getPieSliceTextStyle() {
        return this.pieSliceTextStyle;
    }

    @JsOverlay
    public final void setPieSliceTextStyle(Object pieSliceTextStyle) {
        this.pieSliceTextStyle = pieSliceTextStyle;
    }

    @JsOverlay
    public final Object getLegend() {
        return this.legend;
    }

    @JsOverlay
    public final void setLegend(Object legend) {
        this.legend = legend;
    }

    @JsOverlay
    public final String getPieSliceBorderColor() {
        return this.pieSliceBorderColor;
    }

    @JsOverlay
    public final void setPieSliceBorderColor(String pieSliceBorderColor) {
        this.pieSliceBorderColor = pieSliceBorderColor;
    }

    @JsOverlay
    public final Object getTooltip() {
        return this.tooltip;
    }

    @JsOverlay
    public final void setTooltip(Object tooltip) {
        this.tooltip = tooltip;
    }

    @JsOverlay
    public final Boolean getIs3D() {
        return this.is3D;
    }

    @JsOverlay
    public final void setIs3D(Boolean is3D) {
        this.is3D = is3D;
    }

    @JsOverlay
    public final String getTitle() {
        return this.title;
    }

    @JsOverlay
    public final void setTitle(String title) {
        this.title = title;
    }

    @JsOverlay
    public final String[] getColors() {
        return this.colors;
    }

    @JsOverlay
    public final void setColors(String[] colors) {
        this.colors = colors;
    }

    @JsOverlay
    public final Object getTitleTextStyle() {
        return this.titleTextStyle;
    }

    @JsOverlay
    public final void setTitleTextStyle(Object titleTextStyle) {
        this.titleTextStyle = titleTextStyle;
    }

    @JsOverlay
    public final String getPieSliceText() {
        return this.pieSliceText;
    }

    @JsOverlay
    public final void setPieSliceText(String pieSliceText) {
        this.pieSliceText = pieSliceText;
    }

    @JsOverlay
    public final Boolean getReverseCategories() {
        return this.reverseCategories;
    }

    @JsOverlay
    public final void setReverseCategories(Boolean reverseCategories) {
        this.reverseCategories = reverseCategories;
    }

    @JsOverlay
    public final String getFontName() {
        return this.fontName;
    }

    @JsOverlay
    public final void setFontName(String fontName) {
        this.fontName = fontName;
    }

    @JsOverlay
    public final Number getPieStartAngle() {
        return this.pieStartAngle;
    }

    @JsOverlay
    public final void setPieStartAngle(Number pieStartAngle) {
        this.pieStartAngle = pieStartAngle;
    }

    @JsOverlay
    public final Number getSliceVisibilityThreshold() {
        return this.sliceVisibilityThreshold;
    }

    @JsOverlay
    public final void setSliceVisibilityThreshold(Number sliceVisibilityThreshold) {
        this.sliceVisibilityThreshold = sliceVisibilityThreshold;
    }

    @JsOverlay
    public final Boolean getForceIFrame() {
        return this.forceIFrame;
    }

    @JsOverlay
    public final void setForceIFrame(Boolean forceIFrame) {
        this.forceIFrame = forceIFrame;
    }

    @JsOverlay
    public final Number getPieHole() {
        return this.pieHole;
    }

    @JsOverlay
    public final void setPieHole(Number pieHole) {
        this.pieHole = pieHole;
    }

    @JsOverlay
    public final String getPieResidueSliceColor() {
        return this.pieResidueSliceColor;
    }

    @JsOverlay
    public final void setPieResidueSliceColor(String pieResidueSliceColor) {
        this.pieResidueSliceColor = pieResidueSliceColor;
    }

    @JsOverlay
    public final Boolean getEnableInteractivity() {
        return this.enableInteractivity;
    }

    @JsOverlay
    public final void setEnableInteractivity(Boolean enableInteractivity) {
        this.enableInteractivity = enableInteractivity;
    }

    @JsOverlay
    public final Number getWidth() {
        return this.width;
    }

    @JsOverlay
    public final void setWidth(Number width) {
        this.width = width;
    }

    @JsOverlay
    public final Number getFontSize() {
        return this.fontSize;
    }

    @JsOverlay
    public final void setFontSize(Number fontSize) {
        this.fontSize = fontSize;
    }

    @JsOverlay
    public final Object getChartArea() {
        return this.chartArea;
    }

    @JsOverlay
    public final void setChartArea(Object chartArea) {
        this.chartArea = chartArea;
    }

    @JsOverlay
    public final Number getHeight() {
        return this.height;
    }

    @JsOverlay
    public final void setHeight(Number height) {
        this.height = height;
    }

    @JsOverlay
    public final String getPieResidueSliceLabel() {
        return this.pieResidueSliceLabel;
    }

    @JsOverlay
    public final void setPieResidueSliceLabel(String pieResidueSliceLabel) {
        this.pieResidueSliceLabel = pieResidueSliceLabel;
    }

    @JsType(isNative = true, namespace = JsPackage.GLOBAL, name = "Object")
    public static class backgroundColor {
        @JsProperty
        Number strokeWidth;
        @JsProperty
        String fill;
        @JsProperty
        String stroke;

        @JsOverlay
        public final Number getStrokeWidth() {
            return this.strokeWidth;
        }

        @JsOverlay
        public final void setStrokeWidth(Number strokeWidth) {
            this.strokeWidth = strokeWidth;
        }

        @JsOverlay
        public final String getFill() {
            return this.fill;
        }

        @JsOverlay
        public final void setFill(String fill) {
            this.fill = fill;
        }

        @JsOverlay
        public final String getStroke() {
            return this.stroke;
        }

        @JsOverlay
        public final void setStroke(String stroke) {
            this.stroke = stroke;
        }

    }

    @JsType(isNative = true, namespace = JsPackage.GLOBAL, name = "Object")
    public static class legend {
        @JsProperty
        Number maxLines;
        @JsProperty
        String position;
        @JsProperty
        Object textStyle;
        @JsProperty
        String alignment;

        @JsOverlay
        public final Number getMaxLines() {
            return this.maxLines;
        }

        @JsOverlay
        public final void setMaxLines(Number maxLines) {
            this.maxLines = maxLines;
        }

        @JsOverlay
        public final String getPosition() {
            return this.position;
        }

        @JsOverlay
        public final void setPosition(String position) {
            this.position = position;
        }

        @JsOverlay
        public final Object getTextStyle() {
            return this.textStyle;
        }

        @JsOverlay
        public final void setTextStyle(Object textStyle) {
            this.textStyle = textStyle;
        }

        @JsOverlay
        public final String getAlignment() {
            return this.alignment;
        }

        @JsOverlay
        public final void setAlignment(String alignment) {
            this.alignment = alignment;
        }

    }

    @JsType(isNative = true, namespace = JsPackage.GLOBAL, name = "Object")
    public static class tooltip {
        @JsProperty
        Boolean showColorCode;
        @JsProperty
        Boolean isHtml;
        @JsProperty
        String text;
        @JsProperty
        Object textStyle;
        @JsProperty
        String trigger;
        @JsProperty
        Boolean ignoreBounds;

        @JsOverlay
        public final Boolean getShowColorCode() {
            return this.showColorCode;
        }

        @JsOverlay
        public final void setShowColorCode(Boolean showColorCode) {
            this.showColorCode = showColorCode;
        }

        @JsOverlay
        public final Boolean getIsHtml() {
            return this.isHtml;
        }

        @JsOverlay
        public final void setIsHtml(Boolean isHtml) {
            this.isHtml = isHtml;
        }

        @JsOverlay
        public final String getText() {
            return this.text;
        }

        @JsOverlay
        public final void setText(String text) {
            this.text = text;
        }

        @JsOverlay
        public final Object getTextStyle() {
            return this.textStyle;
        }

        @JsOverlay
        public final void setTextStyle(Object textStyle) {
            this.textStyle = textStyle;
        }

        @JsOverlay
        public final String getTrigger() {
            return this.trigger;
        }

        @JsOverlay
        public final void setTrigger(String trigger) {
            this.trigger = trigger;
        }

        @JsOverlay
        public final Boolean getIgnoreBounds() {
            return this.ignoreBounds;
        }

        @JsOverlay
        public final void setIgnoreBounds(Boolean ignoreBounds) {
            this.ignoreBounds = ignoreBounds;
        }

    }

    @JsType(isNative = true, namespace = JsPackage.GLOBAL, name = "Object")
    public static class chartArea {
        @JsProperty
        Object backgroundColor;
        @JsProperty
        String top;
        @JsProperty
        String left;
        @JsProperty
        String width;
        @JsProperty
        String height;

        @JsOverlay
        public final Object getBackgroundColor() {
            return this.backgroundColor;
        }

        @JsOverlay
        public final void setBackgroundColor(Object backgroundColor) {
            this.backgroundColor = backgroundColor;
        }

        @JsOverlay
        public final String getTop() {
            return this.top;
        }

        @JsOverlay
        public final void setTop(String top) {
            this.top = top;
        }

        @JsOverlay
        public final String getLeft() {
            return this.left;
        }

        @JsOverlay
        public final void setLeft(String left) {
            this.left = left;
        }

        @JsOverlay
        public final String getWidth() {
            return this.width;
        }

        @JsOverlay
        public final void setWidth(String width) {
            this.width = width;
        }

        @JsOverlay
        public final String getHeight() {
            return this.height;
        }

        @JsOverlay
        public final void setHeight(String height) {
            this.height = height;
        }

    }

}
